import EadHelper from "./helper";

class EadGoogleDriveHandler {
	static driveclientId = emebeder.driveclientId;
	static oauthToken;

	static googlehandler(callback) {
		if (!this.driveclientId) {
			return;
		}

		if (!this.oauthToken) {
			gapi.load("auth", {
				callback: function () {
					EadGoogleDriveHandler.onauthapiload(callback);
				}
			});
			gapi.load("picker", 1);
		} else {
			EadGoogleDriveHandler.createpicker(callback);
		}
	}

	static onauthapiload(callback) {
		window.gapi.auth.authorize(
			{
				client_id: this.driveclientId,
				scope: ["https://www.googleapis.com/auth/drive"]
			},
			function (authResult) {
				EadGoogleDriveHandler.handle_auth_result(authResult, callback);
			}
		);
	}

	static handle_auth_result(authResult, callback) {
		if (authResult && !authResult.error) {
			this.oauthToken = authResult.access_token;
			EadGoogleDriveHandler.createpicker(callback);
		}
	}

	static createpicker(callback) {
		let docsView = new google.picker.DocsView().setMimeTypes(
			emebeder.validtypes
		);
		if (emebeder.gpicker_view === "folder") {
			docsView.setIncludeFolders(true).setParent("root");
		}
		let picker = new google.picker.PickerBuilder()
			.enableFeature(google.picker.Feature.SUPPORT_DRIVES)
			.addView(new google.picker.DocsUploadView().setIncludeFolders(true))
			.addView(docsView)
			.addView(new google.picker.DocsView().setEnableDrives(true))
			.addView(google.picker.ViewId.DOCUMENTS)
			.addView(google.picker.ViewId.PRESENTATIONS)
			.addView(google.picker.ViewId.SPREADSHEETS)
			.addView(google.picker.ViewId.FORMS)
			.setOAuthToken(this.oauthToken)
			.setCallback(function (data) {
				EadGoogleDriveHandler.picker_callback(data, callback);
			})
			.build();
		picker.setVisible(true);
	}

	static picker_callback(data, callback) {
		let file = "";

		if (data[google.picker.Response.ACTION] == google.picker.Action.PICKED) {
			let doc = data[google.picker.Response.DOCUMENTS][0];
			let filesize = 0;
			if (doc.sizeBytes) {
				filesize = EadHelper.getHumanReadableFilesize(doc.sizeBytes);
			}
			file = {
				id: doc.id,
				filename: doc.name,
				filesizeHumanReadable: filesize
			};
			if (doc.embedUrl) {
				file.url = doc.embedUrl;
			} else {
				file.url = false;
				file.id = doc.id;
			}
			callback(file);
		}
	}
}
export default EadGoogleDriveHandler;
